#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) smooth in vec2 _fin_fragTexCoord;
layout(location = 1) smooth in vec4 _fin_fragColor;

struct SFragmentInput
{
	vec2 fragTexCoord;
	vec4 fragColor;
	bool IsFrontFace;
};

layout(location = 0) out vec4 _fout_outColor;

struct SFragmentOutput
{
	vec4 outColor;
};

 uniform sampler2D Texture;




void FragmentMain( in SFragmentInput  fInput,  out SFragmentOutput  fOutput  )
{
	fOutput.outColor = fInput.fragColor *  texture(Texture, fInput.fragTexCoord) .r;
}


void main()
{
	SFragmentInput fInput;
	SFragmentOutput fOutput;

	fInput.fragTexCoord = _fin_fragTexCoord;
	fInput.fragColor = _fin_fragColor;
	fInput.IsFrontFace = gl_FrontFacing;
	FragmentMain(fInput, fOutput);
	_fout_outColor = fOutput.outColor;
}
