#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec3 _vin_Position;

struct SVertexInput
{
	vec3 Position;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragWorldPosition;

struct SVertexOutput
{
	vec4 fragWorldPosition;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	vec2 ViewportSize;
	float Handedness;
} SceneInfo;

layout( std140) uniform UMeshVertexConstant
{
	mat4 ModelMatrix;
} MeshVertexConstant;


mat4 GetMeshMatrix( in SVertexInput  vInput  )
{
	return  mat4(vec4(1, 0, 0, 0), vec4(0, 1, 0, 0), vec4(0, 0, 1, 0), vec4(0, 0, 0, 1)) ;

}




void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
	mat4 mvp =  (( SceneInfo.ViewProj ) * ( MeshVertexConstant.ModelMatrix )) ;
	vOutput.VertexPosition =  ((mvp) * (vec4(vInput.Position, 1.0))) ;
	vOutput.fragWorldPosition = vOutput.VertexPosition;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragWorldPosition = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragWorldPosition = vOutput.fragWorldPosition;
	gl_Position = vOutput.VertexPosition;
}
