#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout(std430 ) buffer BInOutCounts
{
	uint InOutCounts[];
} InOutCounts;

layout( std140) uniform UInfo
{
	uint CurrentBit;
	uint GroupCount;
} Info;

shared uvec4 groupCounts[576];




void ComputeMain( in SComputeInput  cInput  )
{
	const uint localThreadID = cInput.LocalThreadID.x;
	const uint groupCount =  Info.GroupCount ;

	{
		const uint ai = localThreadID * 4;
		if (localThreadID < groupCount)
		{

			for (uint k = 0; k < 4; ++k)
				groupCounts [ ((ai + k) + ((ai + k) >> 3)) ] =  uvec4( InOutCounts.InOutCounts [ ((ai + k) * 4) ], InOutCounts.InOutCounts [( ((ai + k) * 4) ) + 1], InOutCounts.InOutCounts [( ((ai + k) * 4) ) + 2], InOutCounts.InOutCounts [( ((ai + k) * 4) ) + 3]) ;
		}
		else
		{

			for (uint k = 0; k < 4; ++k)
				groupCounts [ ((ai + k) + ((ai + k) >> 3)) ] = uvec4(0, 0, 0, 0);
		}
	}

	groupMemoryBarrier(); barrier(); ;

	for (uint offseti =  128 ; offseti < groupCount; offseti +=  128 )
	{


		if (offseti + localThreadID < groupCount)
		{
			const uint ai = localThreadID * 4;
			const uint bi = (offseti + localThreadID) * 4;


			for (uint k = 0; k < 4; ++k)
				groupCounts [ ((ai + k) + ((ai + k) >> 3)) ] +=  uvec4( InOutCounts.InOutCounts [ ((bi + k) * 4) ], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 1], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 2], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 3]) ;
		}
	}

	groupMemoryBarrier(); barrier(); ;
	{

		uint ai = localThreadID * 2;
		uint bi = localThreadID * 2 +  128  * 2;

		groupCounts [ ((ai) + ((ai) >> 3)) ] +=  groupCounts [ ((bi) + ((bi) >> 3)) ];
		groupCounts [ ((ai + 1) + ((ai + 1) >> 3)) ] +=  groupCounts [ ((bi + 1) + ((bi + 1) >> 3)) ];
	}
	for (uint d =  128  / 4; d > 0; d /= 2)
	{
		groupMemoryBarrier(); barrier(); ;
		if (localThreadID < d * 4)
		{
			uint ai = localThreadID;
			uint bi = localThreadID + d * 4;

			groupCounts [ ((ai) + ((ai) >> 3)) ] +=  groupCounts [ ((bi) + ((bi) >> 3)) ];
		}
	}
	groupMemoryBarrier(); barrier(); ;

	uvec4 offsetGlobal[4];
	{
		offsetGlobal[0].x = 0;
		offsetGlobal[0].y = offsetGlobal[0].x +  groupCounts [ ((0) + ((0) >> 3)) ].x;
		offsetGlobal[0].z = offsetGlobal[0].y +  groupCounts [ ((0) + ((0) >> 3)) ].y;
		offsetGlobal[0].w = offsetGlobal[0].z +  groupCounts [ ((0) + ((0) >> 3)) ].z;

		for (uint k = 1; k < 4; ++k)
		{
			offsetGlobal[k].x = offsetGlobal[k - 1].w +  groupCounts [ ((k - 1) + ((k - 1) >> 3)) ].w;
			offsetGlobal[k].y = offsetGlobal[k ].x +  groupCounts [ ((k) + ((k) >> 3)) ].x;
			offsetGlobal[k].z = offsetGlobal[k ].y +  groupCounts [ ((k) + ((k) >> 3)) ].y;
			offsetGlobal[k].w = offsetGlobal[k ].z +  groupCounts [ ((k) + ((k) >> 3)) ].z;
		}
	}

	uvec4 totalCountsPrevious[4];
	{

		for (uint k = 0; k < 4; ++k)
			totalCountsPrevious[k] = uvec4(0, 0, 0, 0);
	}



	for (uint offseti = 0; offseti < groupCount; offseti +=  128 )
	{

		groupMemoryBarrier(); barrier(); ;


		if (offseti + localThreadID < groupCount)
		{
			const uint ai = localThreadID * 4;
			const uint bi = (offseti + localThreadID) * 4;


			for (uint k = 0; k < 4; ++k)
				groupCounts [ ((ai + k) + ((ai + k) >> 3)) ] =  uvec4( InOutCounts.InOutCounts [ ((bi + k) * 4) ], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 1], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 2], InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 3]) ;
		}
		else
		{
			const uint ai = localThreadID * 4;


			for (uint k = 0; k < 4; ++k)
			{
				groupCounts [ ((ai + k) + ((ai + k) >> 3)) ] = uvec4(0, 0, 0, 0);
			}
		}






		uint stride = 1;
		{
			groupMemoryBarrier(); barrier(); ;

			uint localLane = localThreadID / 2;
			uint localOffset = (localThreadID & 1);
			uint ai = ((localLane * 2 + 1) * stride - 1) * 4;
			uint bi = ((localLane * 2 + 2) * stride - 1) * 4;
			groupCounts [ ((bi + localOffset) + ((bi + localOffset) >> 3)) ] +=  groupCounts [ ((ai + localOffset) + ((ai + localOffset) >> 3)) ];
			groupCounts [ ((bi + localOffset + 2) + ((bi + localOffset + 2) >> 3)) ] +=  groupCounts [ ((ai + localOffset + 2) + ((ai + localOffset + 2) >> 3)) ];
			stride *= 2;
		}
		for (uint d =  128  / 4; d > 0; d /= 2)
		{
			groupMemoryBarrier(); barrier(); ;
			if (localThreadID < d * 4)
			{

				uint localLane = localThreadID / 4;
				uint localOffset = localThreadID & 3;
				uint ai = ((localLane * 2 + 1) * stride - 1) * 4;
				uint bi = ((localLane * 2 + 2) * stride - 1) * 4;
				groupCounts [ ((bi + localOffset) + ((bi + localOffset) >> 3)) ] +=  groupCounts [ ((ai + localOffset) + ((ai + localOffset) >> 3)) ];
			}
			stride *= 2;
		}

		for (uint d = 1; d <  128  / 2; d *= 2)
		{
			stride /= 2;
			groupMemoryBarrier(); barrier(); ;
			if (localThreadID > 3 && localThreadID < d * 4)
			{

				uint localLane = localThreadID / 4;
				uint localOffset = localThreadID & 3;
				uint ai = ((localLane * 2 + 0) * stride - 1) * 4;
				uint bi = ((localLane * 2 + 1) * stride - 1) * 4;

				groupCounts [ ((bi + localOffset) + ((bi + localOffset) >> 3)) ] +=  groupCounts [ ((ai + localOffset) + ((ai + localOffset) >> 3)) ];
			}
		}
		{
			stride /= 2;
			groupMemoryBarrier(); barrier(); ;
			if (localThreadID > 1)
			{

				uint localLane = localThreadID / 2;
				uint localOffset = localThreadID & 1;
				uint ai = ((localLane * 2 + 0) * stride - 1) * 4;
				uint bi = ((localLane * 2 + 1) * stride - 1) * 4;

				groupCounts [ ((bi + localOffset) + ((bi + localOffset) >> 3)) ] +=  groupCounts [ ((ai + localOffset) + ((ai + localOffset) >> 3)) ];
				groupCounts [ ((bi + localOffset + 2) + ((bi + localOffset + 2) >> 3)) ] +=  groupCounts [ ((ai + localOffset + 2) + ((ai + localOffset + 2) >> 3)) ];
			}
		}


		groupMemoryBarrier(); barrier(); ;

		if (localThreadID == 0 && (offseti + localThreadID < groupCount))
		{
			const uint bi = (offseti + localThreadID) * 4;


			for (uint k = 0; k < 4; ++k)
			{
				InOutCounts.InOutCounts [ ((bi + k) * 4) ] = (offsetGlobal[k] + totalCountsPrevious[k]).x; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 1] = (offsetGlobal[k] + totalCountsPrevious[k]).y; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 2] = (offsetGlobal[k] + totalCountsPrevious[k]).z; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 3] = (offsetGlobal[k] + totalCountsPrevious[k]).w; ;
			}
		}

		if (localThreadID !=  128  - 1 && (offseti + localThreadID + 1 < groupCount))
		{
			const uint ai = localThreadID * 4;
			const uint bi = (offseti + localThreadID + 1) * 4;


			for (uint k = 0; k < 4; ++k)
			{
				InOutCounts.InOutCounts [ ((bi + k) * 4) ] = (offsetGlobal[k] + totalCountsPrevious[k] + groupCounts [ ((ai + k) + ((ai + k) >> 3)) ]).x; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 1] = (offsetGlobal[k] + totalCountsPrevious[k] + groupCounts [ ((ai + k) + ((ai + k) >> 3)) ]).y; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 2] = (offsetGlobal[k] + totalCountsPrevious[k] + groupCounts [ ((ai + k) + ((ai + k) >> 3)) ]).z; InOutCounts.InOutCounts [( ((bi + k) * 4) ) + 3] = (offsetGlobal[k] + totalCountsPrevious[k] + groupCounts [ ((ai + k) + ((ai + k) >> 3)) ]).w; ;
			}
		}



		{
			const uint ai = ( 128  - 1) * 4;


			for (uint k = 0; k < 4; ++k)
			{
				totalCountsPrevious[k] +=  groupCounts [ ((ai + k) + ((ai + k) >> 3)) ];
			}
		}
	}
}

layout(local_size_x = 128, local_size_y = 1, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
